CON
{***************************************
 *  SPIO Demo 8 x 8 led/keypad demo    *
 *  Author: Kurt Winn March 2013       *
 *  Copyright (c) 2013 Kurt Winn       *
 *  See end of file for terms of use.  *
 ***************************************
}

'CON
        _clkmode = xtal1 + pll16x                       'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000

        clk_freq = (_clkmode >> 6) * _xinfreq           ' system freq as a constant
        ms001   = clk_freq / 1_000                      ' ticks in 1ms
        us001   = clk_freq / 1_000_000                  ' ticks in 1us

'********************************************************************************************************
' Serial port definitions ; Port0 - programming and debug port .
'********************************************************************************************************
  p0rx = 31
  p0tx = 30
  baudrate = 115200

' **************************************************************************************************************************
' Constants required by shift register input/output subroutine 
' **************************************************************************************************************************
  ParClk        = 0
  SerClk        = 1
  DIO           = 2
  diagpin       = 7
  on            = 1
  off           = 0
  bytecnt       = 1
  blank         = 0

VAR
  byte  led
  byte  dig
  byte  val
  byte  rown
  word  temp1
'**************************************************************************************************************************************
OBJ

  ser   :       "FDSQ-64"       ' .init .AddPort(port,rxpin,txpin,ctspin,rtspin,rtsthreshold,mode,baudrate) init and add up to 4 ports
                                ' .start .Stop .getCogID .rxflush(port) .rxcheck(port) .rxtime(port,ms) .rx(port) .rxstr(port, rxbuff, strterm)
                                ' .tx(port,txbyte) .txflush(port) .str(port,stringptr) .strln(port,strAddr) .dec(port,value)
                                ' .decf(port,value, width) .decx(port,value, digits) .decl(port,value,digits,flag) .hex(port,value, digits)
                                ' .ihex(port,value, digits) .bin(port,value, digits) .padchar(port,count, txbyte) .ibin(port,value, digits)
                                ' .putc(port,txbyte) .newline(port) .cls(port) .getc(port)
  time  :       "timer"         ' .start .startx(now) .set(ms) .millis .seconds .adjust(offset) .mark .get_sync .pause(ms) .pause_us(us)
  io8   :       "SPIO"          ' 8 x 8 multiplexed input output driver
    

PUB SPIODemo | row, col, num, t1, t2

  time.start
  ser.init
  ser.AddPort(0, p0rx, p0tx, -1, -1, 0, 0, 115200)
  ser.start
  time.pause(5000)

  ser.tx(0, 16)               ' clear screen
  


  ser.str(0, string(" Press any key to continue "))
  val := (ser.rx(0))

  io8.main(ParClk, SerClk, DIO)                       ' initialize the mux cog

  temp1 := io8.getOutdata
  ser.str(0, string("OutData = ")) 
  ser.hex(0, temp1, 4)
  temp1 := io8.getIndata
  ser.str(0, string(" InData = ")) 
  ser.hex(0, temp1, 4)

'  diagnit
'  blink(5)
  printrow
  printsw

repeat
                        
    ser.tx(0, 13)
    ser.str(0, string("Enter 1 for led test, 2 for decimal point test, or 3 for segment test "))
    val := (ser.rx(0))
'    io8.fill(0)   ' fill array with 0
    case val
      "1":  ' turns on each column of leds or a segment for 5 seconds
        repeat row from 0 to 7
          io8.fill(0)
          repeat dig from 1 to 64 step 8
            io8.setled((row + dig), on)
          printrow
          printsw
          ser.rx(0)
         
      "2":  ' turns on the decimal point (led8) for each row in turn
          io8.fill(0)
        repeat row from 0 to 7
          io8.setdp( row + 1)
          printrow
          printsw
          ser.rx(0)

      "3":  ' sets 7 segment digits to values in segment table (0-9, a - F, and decimal point)
        repeat num from 0 to 16
          repeat row from 0 to 7
            io8.setdig( row + 1, num)
          printrow
          printsw
          ser.rx(0)

pri printrow | row, bits
    ser.tx(0, 13)
    ser.str(0, string("   LedArray data "))
     repeat row from 1 to 8
      bits := io8.getled(row)
      ser.hex(0, bits, 2)
      ser.str(0, string(", ")) 

pri printsw | row, bits
    ser.tx(0, 13)
    ser.str(0, string("SwitchArray data "))
    repeat row from 1 to 8
      bits := io8.getsw(row)
      ser.hex(0, bits, 2)
      ser.str(0, string(", ")) 

pri diagnit
  dira[0..8]~~
  outa[0..8]~~
  
pri blink(times)
  repeat times
    outa[diagpin]~
    time.pause(200)
    outa[diagpin]~~
    time.pause(200)
time.pause(800)